#line 1 "f:/Stevan/ForLibStock/rtos-lib/example5.c"
#line 1 "f:/stevan/forlibstock/rtos-lib/rtos.h"







typedef void (*TaskType)(void);

typedef struct TaskDescriptor
{
 unsigned int *StackPointer;
 struct TaskDescriptor *NextTask;
 unsigned char TID;
 unsigned char TaskStatus;
 int Sleep;
 TaskType Function;
} TaskDescriptor;

struct item_list{
 struct item_list *IR_NEXT;
 struct TaskDescriptor *IR_WAIT;
 int ID;
};

typedef struct item_list ITEM;
typedef ITEM *ITEMPTR;

struct semaphore{
 int S_COUNT;
 struct item_list *S_QH;
 struct item_list *S_QT;
};

typedef struct semaphore SEM;
typedef SEM *SEMPTR;

unsigned char *InitStack(unsigned char*, TaskType , TaskType);
int RTOS_CreateTask( TaskType func,
 unsigned char *StackStart,
 unsigned char StackSize,
 unsigned int Tid);

void RTOS_Init(void);
void RTOS_Schedule(void);
int RTOS_StartScheduler(void);
void RTOS_StartTimer(void);
void RTOS_CreateSemaphore(SEMPTR sem1, int count);
void RTOS_OpenSemaphore(SEM *sem1);
void RTOS_ReleaseSemaphore(SEM *sem1);
void RTOS_Sleep(int ticks);
void RTOS_Suspend(int id);
void RTOS_Resume(int id);
void RTOS_MonoTask(void);
void RTOS_ResumeTasking(void);

void RTOS_Yield(void);
void RTOS_KillTask(int id);
void RTOS_Terminator(void);
#line 22 "f:/Stevan/ForLibStock/rtos-lib/example5.c"
unsigned char TaskStack[ 5 ][ 100 ];
SEM s1, s2, s3, s4;
int i1,i2,i3,i4;

void Task0(void)
{
 while(1){
 RTOS_Yield();
 }
}

void Task1(void)
{
 while(1){
 RTOS_OpenSemaphore(&s1);
 for(i1=0; i1<10; i1++)
 {
 PORTB.F1=~PORTB.F1;
 RTOS_Sleep(300);
 }
 RTOS_ReleaseSemaphore(&s2);
 }
}

void Task2(void)
{
 while(1){
 RTOS_OpenSemaphore(&s2);
 for(i2=0; i2<10; i2++)
 {
 PORTB.F2=~PORTB.F2;
 RTOS_Sleep(300);
 }
 RTOS_ReleaseSemaphore(&s1);
 }
}

void Task3(void)
{
 while(1){
 RTOS_OpenSemaphore(&s3);
 for(i3=0; i3<10; i3++)
 {
 PORTB.F3=~PORTB.F3;
 RTOS_Sleep(300);
 }
 RTOS_ReleaseSemaphore(&s4);
 }
}

void Task4(void)
{
 while(1){
 RTOS_OpenSemaphore(&s4);
 for(i4=0; i4<10; i4++)
 {
 PORTB.F4=~PORTB.F4;
 RTOS_Sleep(300);
 }
 RTOS_ReleaseSemaphore(&s3);
 }
}

void main() {
 CMCON |= 0x07;
 ADCON1 |= 0x0C;
 TRISB = 0;
 PORTB = 0x00;
 Delay_ms(500);

 RTOS_CreateSemaphore(&s1, 1);
 RTOS_CreateSemaphore(&s2, 0);
 RTOS_CreateSemaphore(&s3, 1);
 RTOS_CreateSemaphore(&s4, 0);

 RTOS_Init();
 RTOS_CreateTask((TaskType)Task0,TaskStack[0], sizeof (TaskStack[0]), 0);
 RTOS_CreateTask((TaskType)Task1,TaskStack[1], sizeof (TaskStack[1]), 1);
 RTOS_CreateTask((TaskType)Task2,TaskStack[2], sizeof (TaskStack[2]), 2);
 RTOS_CreateTask((TaskType)Task3,TaskStack[3], sizeof (TaskStack[3]), 3);
 RTOS_CreateTask((TaskType)Task4,TaskStack[4], sizeof (TaskStack[4]), 4);
 RTOS_StartScheduler();
 while(1){}
}
