#ifndef NTASKS
#define NTASKS        5
#endif

#define TASK_STACK 100

/******************************/
typedef void (*TaskType)(void);

typedef struct TaskDescriptor
{
        unsigned int        *StackPointer; // ActiveTask stack pointer
        struct TaskDescriptor *NextTask;   // Who's next
        unsigned char TID;                 // Task id
        unsigned char TaskStatus;          // Task status
        int Sleep;
        TaskType Function;     // Function to call for ActiveTask
} TaskDescriptor;

struct item_list{
        struct item_list *IR_NEXT;
        struct TaskDescriptor *IR_WAIT;
        int ID;
};

typedef struct item_list ITEM;
typedef ITEM *ITEMPTR;

struct semaphore{
        int S_COUNT;
        struct item_list *S_QH;
        struct item_list *S_QT;
};

typedef struct semaphore SEM;
typedef SEM *SEMPTR;

unsigned char *InitStack(unsigned char*, TaskType , TaskType);
int RTOS_CreateTask( TaskType func,
                        unsigned char *StackStart,
                        unsigned char StackSize,
                        unsigned int Tid);

void RTOS_Init(void);
void RTOS_Schedule(void);
int RTOS_StartScheduler(void);
void RTOS_StartTimer(void);
void RTOS_CreateSemaphore(SEMPTR sem1, int count);
void RTOS_OpenSemaphore(SEM *sem1);
void RTOS_ReleaseSemaphore(SEM *sem1);
void RTOS_Sleep(int ticks);
void RTOS_Suspend(int id);
void RTOS_Resume(int id);
void RTOS_MonoTask(void);
void RTOS_ResumeTasking(void);
//  Not yet finished
void RTOS_Yield(void);
void RTOS_KillTask(int id);
void RTOS_Terminator(void);